
local StoneGateV3 = ...

-- Register common prefab nodes
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionA/DecorationDoorPart", "STONE_GATE_V3_DOOR_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionA/WallAccessPart", "STONE_GATE_V3_WALL_PORTE_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/SFenetrePart", "STONE_GATE_V3_DECORATION_SFENETRE_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/LFenetrePart", "STONE_GATE_V3_DECORATION_LFENETRE_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/ArrowSlitPart", "STONE_GATE_V3_DECORATION_ARROWSLIT_PREFAB")

-- Register core B (Gate) prefab nodes
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/step_0_RootPart", "STONE_GATE_V3_COREB_ROOT_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/step_3_TopPart", "STONE_GATE_V3_COREB_TOP_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/step_2_Tiling2Part", "STONE_GATE_V3_COREB_TILING2_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/step_1_Tiling3Part", "STONE_GATE_V3_COREB_TILING3_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/DecorationPortePart", "STONE_GATE_V3_COREB_PORTE_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/DecorationMuretPart", "STONE_GATE_V3_COREB_MURET_PREFAB")

-- Register core C (Octogonal tower) prefab nodes
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/step_0_RootPart", "STONE_GATE_V3_COREC_ROOT_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/step_3_TopPart", "STONE_GATE_V3_COREC_TOP_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/step_2_Tiling2Part", "STONE_GATE_V3_COREC_TILING2_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/step_1_Tiling3Part", "STONE_GATE_V3_COREC_TILING3_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/DecorationPortePart", "STONE_GATE_V3_COREC_PORTE_PREFAB")

-- Register core D (Smal squared tower) prefab nodes
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/step_0_RootPart", "STONE_GATE_V3_CORED_ROOT_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/step_3_TopPart", "STONE_GATE_V3_CORED_TOP_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/step_2_Tiling2Part", "STONE_GATE_V3_CORED_TILING2_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/step_1_Tiling3Part", "STONE_GATE_V3_CORED_TILING3_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/RoofPart", "STONE_GATE_V3_CORED_ROOF_PREFAB")
StoneGateV3:registerAssetId("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/RoofBPart", "STONE_GATE_V3_CORED_ROOFB_PREFAB")
--------------------------------------------------------------------------

-- Create default building part registering function 
function registerDefaultBuildingPart(_nodePrefix)
	StoneGateV3:register({
		DataType = "BUILDING_PART",
		Id = _nodePrefix .. "_PART",
		Mover = { DataType = "BUILDING_PART_MOVER" },
		ConstructorData = { DataType = "BUILDING_CONSTRUCTOR_DEFAULT", CoreObjectPrefab = _nodePrefix .. "_PREFAB" }
	})
end

local defaultNodePrefixList = {
	"STONE_GATE_V3_COREB_TOP",
	"STONE_GATE_V3_COREB_TILING2",
	"STONE_GATE_V3_COREB_TILING3",
	"STONE_GATE_V3_COREC_TOP",
	"STONE_GATE_V3_COREC_TILING2",
	"STONE_GATE_V3_COREC_TILING3",
	"STONE_GATE_V3_CORED_TOP",
	"STONE_GATE_V3_CORED_TILING2",
	"STONE_GATE_V3_CORED_TILING3"
}

-- Register simple building part assets
for i, nodePrefix in ipairs(defaultNodePrefixList) do
	registerDefaultBuildingPart(nodePrefix)
end

--------------------------------------------------------------------------
-- Register the stone gate set door part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_DOOR_PART",
	Name = "STONE_GATE_V3_DOOR_NAME",
	Description = "STONE_GATE_V3_DOOR_DESC",
	Category = "DOOR",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_DOOR_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register the stone gate set wall access door part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_WALL_PORTE_PART",
	Name = "STONE_GATE_V3_WALL_PORTE_NAME",
	Description = "STONE_GATE_V3_WALL_PORTE_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_WALL_PORTE_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register the stone gate set core B (gate) part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_COREB_ROOT_PART",
	Name = "STONE_GATE_V3_COREB_ROOT_NAME",
	Description = "STONE_GATE_V3_COREB_ROOT_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "STONE_GATE_V3_COREB_ROOT_PREFAB",
		EndPart = "STONE_GATE_V3_COREB_TOP_PART",
		FillerList = {
			"STONE_GATE_V3_COREB_TILING2_PART"
                },
		BasementFillerList = {
			"STONE_GATE_V3_COREB_TILING3_PART"
         	},
		MinimumScale = 0,
		BasementScale = 1,
		IsVertical = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 5 }
		}
	},
	BuildingFunction = {
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		WorkerCapacity = 2,
                RelatedJob = { Job = "SOLDIER", Behavior = "WORK_BEHAVIOR" }
        }
})

-- Register the stone gate set core B porte (gate access) part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_COREB_PORTE_PART",
	Name = "STONE_GATE_V3_COREB_PORTE_NAME",
	Description = "STONE_GATE_V3_COREB_PORTE_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_COREB_PORTE_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register the stone gate set core B muret part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_COREB_MURET_PART",
	Name = "STONE_GATE_V3_COREB_MURET_NAME",
	Description = "STONE_GATE_V3_COREB_MURET_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_COREB_MURET_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register the stone gate set core C root (Octogonal tower) part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_COREC_ROOT_PART",
	Name = "STONE_GATE_V3_COREC_ROOT_NAME",
	Description = "STONE_GATE_V3_COREC_ROOT_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "STONE_GATE_V3_COREC_ROOT_PREFAB",
		EndPart = "STONE_GATE_V3_COREC_TOP_PART",
		FillerList = {
			"STONE_GATE_V3_COREC_TILING2_PART"
                },
		BasementFillerList = {
			"STONE_GATE_V3_COREC_TILING3_PART"
         	},
		MinimumScale = 1,
		BasementScale = 1,
		IsVertical = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 5 }
		}
	},
	BuildingFunction = { -- kept for compatibility with 2.0.5
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		WorkerCapacity = 5,
                RelatedJob = { Job = "SOLDIER", Behavior = "WORK_BEHAVIOR" }
        }
})

-- Register the stone gate set core C porte (Octogonal tower access) part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_COREC_PORTE_PART",
	Name = "STONE_GATE_V3_COREC_PORTE_NAME",
	Description = "STONE_GATE_V3_COREC_PORTE_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_COREC_PORTE_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	},
	BuildingFunction = { 
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		WorkerCapacity = 1,
                RelatedJob = { Job = "SOLDIER", Behavior = "WORK_BEHAVIOR" }
        }
})

-- Register the stone gate set decoration small window part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_DECORATION_SFENETRE_PART",
	Name = "STONE_GATE_V3_DECORATION_SFENETRE_NAME",
	Description = "STONE_GATE_V3_DECORATION_SFENETRE_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_DECORATION_SFENETRE_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register the stone gate set decoration large window part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_DECORATION_LFENETRE_PART",
	Name = "STONE_GATE_V3_DECORATION_LFENETRE_NAME",
	Description = "STONE_GATE_V3_DECORATION_LFENETRE_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_DECORATION_LFENETRE_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register the stone gate set decoration arrow slit part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_DECORATION_ARROWSLIT_PART",
	Name = "STONE_GATE_V3_DECORATION_ARROWSLIT_NAME",
	Description = "STONE_GATE_V3_DECORATION_ARROWSLIT_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_DECORATION_ARROWSLIT_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register the stone gate set core D root (Small squared tower) part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_CORED_ROOT_PART",
	Name = "STONE_GATE_V3_CORED_ROOT_NAME",
	Description = "STONE_GATE_V3_CORED_ROOT_DESC",
	Category = "CORE",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_SCALER", -- Since there are different types of building constructor, 'DataType' is necessary here
		CoreObjectPrefab = "STONE_GATE_V3_CORED_ROOT_PREFAB",
		EndPart = "STONE_GATE_V3_CORED_TOP_PART",
		FillerList = {
			"STONE_GATE_V3_CORED_TILING2_PART"
                },
		BasementFillerList = {
			"STONE_GATE_V3_CORED_TILING3_PART"
         	},
		MinimumScale = 1,
		BasementScale = 1,
		IsVertical = true
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 5 }
		}
	}
})

-- Register the stone gate set core D roof (Small squared tower rampart) part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_CORED_ROOF_PART",
	Name = "STONE_GATE_V3_CORED_ROOF_NAME",
	Description = "STONE_GATE_V3_CORED_ROOF_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_CORED_ROOF_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register the stone gate set core D roof B (Small squared tower rampart with roof) part
StoneGateV3:register({
	DataType = "BUILDING_PART",
	Id = "STONE_GATE_V3_CORED_ROOFB_PART",
	Name = "STONE_GATE_V3_CORED_ROOFB_NAME",
	Description = "STONE_GATE_V3_CORED_ROOFB_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "STONE_GATE_V3_CORED_ROOFB_PREFAB"
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = 1 }
		}
	}
})

-- Register grounding components

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionA/DecorationDoorPart", {
	DataType = "COMP_GROUNDED"
})


StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionA/WallAccessPart", {
	DataType = "COMP_GROUNDED"
})

--StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/step_0_RootPart", {
--	DataType = "COMP_GROUNDED"
--})

--StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/step_0_RootPart", {
--	DataType = "COMP_GROUNDED"
--})

--StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/step_0_RootPart", {
--	DataType = "COMP_GROUNDED"
--})

--StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/RoofPart", {
--	DataType = "COMP_GROUNDED"
--})

--------------------------------------------------------------------------

-- Register flag assigner component on the collider's type to 'PLATFORM'

StoneGateV3:configurePrefabFlagList("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/DecorationPortePart", { "PLATFORM" })
StoneGateV3:configurePrefabFlagList("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/DecorationPortePart", { "PLATFORM" })
StoneGateV3:configurePrefabFlagList("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/step_3_TopPart", { "PLATFORM" })

 
-- Register grass clearing components

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionA/step_1_Tiling3Part", {
	DataType = "COMP_DIRT_RECTANGLE",
	Size = {4, 4}
})

-- Override building part components properties (generated by the building asset processor) to add building zones

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/step_0_RootPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 0, 0 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionA/DecorationDoorPart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "DOOR", -- Allows the door to be used as entrance
	HasBuildingZone = true,
	BuildingZone = { 1, 1 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/DecorationPortePart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 1, 1 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/step_0_RootPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 9, 9 } -- approximative
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/step_0_RootPart", {
	DataType = "COMP_BUILDING_PART",
	HasBuildingZone = true,
	BuildingZone = { 4, 4 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/DecorationPortePart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the roofs)
	BuildingZone = { 1, 1 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionB/DecorationMuretPart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the roofs)
	BuildingZone = { 4, 4 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/DecorationPortePart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the roofs)
	BuildingZone = { 4, 4 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/SFenetrePart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the facades)
	BuildingZone = { 4, 4 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/LFenetrePart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the facades)
	BuildingZone = { 4, 4 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionC/ArrowSlitPart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the facades)
	BuildingZone = { 4, 4 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/RoofPart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the roofs)
	BuildingZone = { 4, 4 }
})

StoneGateV3:registerPrefabComponent("models/cubicTower.fbx/Prefab/cubicTower/ExtensionD/RoofBPart", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the roofs)
	BuildingZone = { 4, 4 }
})
